<?php

namespace App\Filament\Resources\Panel;

use Filament\Forms;
use Filament\Tables;
use Livewire\Component;
use Filament\Forms\Form;
use App\Models\MonyType;
use Filament\Tables\Table;
use Filament\Resources\Resource;
use Filament\Forms\Components\Grid;
use Filament\Forms\Components\Section;
use Filament\Tables\Columns\TextColumn;
use Filament\Forms\Components\TextInput;
use Illuminate\Database\Eloquent\Builder;
use App\Filament\Resources\Panel\MonyTypeResource\Pages;
use App\Filament\Resources\Panel\MonyTypeResource\RelationManagers;

class MonyTypeResource extends Resource
{
    protected static ?string $model = MonyType::class;

    protected static ?string $navigationIcon = 'heroicon-o-rectangle-stack';

    protected static ?int $navigationSort = 3;

    protected static ?string $navigationGroup = 'البيانات الأساسيه';

    public static function getModelLabel(): string
    {
        return __('crud.monyTypes.itemTitle');
    }

    public static function getPluralModelLabel(): string
    {
        return __('crud.monyTypes.collectionTitle');
    }

    public static function getNavigationLabel(): string
    {
        return __('crud.monyTypes.collectionTitle');
    }

    public static function form(Form $form): Form
    {
        return $form->schema([
            Section::make()->schema([
                Grid::make(['default' => 1])->schema([
                    TextInput::make('name')
                        ->required()
                        ->string()
                        ->unique('mony_types', 'name', ignoreRecord: true)
                        ->autofocus(),
                ]),
            ]),
        ]);
    }

    public static function table(Table $table): Table
    {
        return $table
            ->poll('60s')
            ->columns([TextColumn::make('name')->badge()
            ->searchable()
            ->sortable()
            ->toggleable()
            
            ])
            ->filters([])
            ->actions([
                Tables\Actions\EditAction::make(),
                Tables\Actions\ViewAction::make(),
            ])
            ->bulkActions([
                Tables\Actions\BulkActionGroup::make([
                    Tables\Actions\DeleteBulkAction::make(),
                ]),
            ])
            ->defaultSort('id', 'desc');
    }

    public static function getRelations(): array
    {
        return [];
    }

    public static function getPages(): array
    {
        return [
            'index' => Pages\ListMonyTypes::route('/'),
            'create' => Pages\CreateMonyType::route('/create'),
            'view' => Pages\ViewMonyType::route('/{record}'),
            'edit' => Pages\EditMonyType::route('/{record}/edit'),
        ];
    }
}
